jQuery( function ( $ ) {

    var FrontendScripts = {
        init : function () {
            $( document ).on( 'click' , '.rs_copy_clipboard_image' , this.copy_to_clipboard ) ;
            $( document ).on( 'change' , 'input, wcva_attribute_radio' , this.message_for_variations ) ;
        } ,
        copy_to_clipboard : function () {
            var temp = $( '<input>' ) ;
            $( 'body' ).append( temp ) ;
            var url = $( this ).attr( 'data-referralurl' ) ;
            temp.val( url ).select() ;
            document.execCommand( 'copy' ) ;
            $( '.rs_alert_div_for_copy' ).css( { display : 'block' } ).delay( 7000 ).fadeOut() ;
            temp.remove() ;
        } ,
        message_for_variations : function ( ) {
            if ( ! $( this ).closest( 'div.single_variation_wrap' ).find( 'input:hidden[name=variation_id], input.variation_id' ).length )
                return false ;

            var variationid = $( this ).closest( 'div.single_variation_wrap' ).find( 'input:hidden[name=variation_id], input.variation_id' ).val() ;
            if ( variationid === '' || variationid === 0 || variationid === undefined ) {
                $( '#value_variable_product' ).hide() ;
                $( '#buy_Point_value_variable_product' ).hide() ;
                return false ;
            } else {
                $( '#value_variable_product1' ).hide() ;
                $( '#value_variable_product2' ).hide() ;
                var data = ( {
                    action : 'getvariationpoints' ,
                    variationid : variationid ,
                    sumo_security : fp_frontend_scripts_params.variation_msg
                } ) ;
                $.post( fp_frontend_scripts_params.ajax_url , data , function ( response ) {
                    if ( true === response.success ) {

                        if ( fp_frontend_scripts_params.productpurchasecheckbox == 'yes' ) {
                            if ( fp_frontend_scripts_params.showreferralmsg == '1' ) {
                                if ( fp_frontend_scripts_params.loggedinuser == "logged_in_user" ) {
                                    if ( fp_frontend_scripts_params.showearnmsg == '1' && response.data.earnpointmsg != '' ) {
                                        $( '.variableshopmessage' ).show() ;
                                        $( '.variableshopmessage' ).html( response.data.earnpointmsg ) ;
                                    }
                                } else {
                                    if ( fp_frontend_scripts_params.showearnmsg_guest == '1' && response.data.earnpointmsg != '' ) {
                                        $( '.variableshopmessage' ).show() ;
                                        $( '.variableshopmessage' ).html( response.data.earnpointmsg ) ;
                                    }
                                }
                                $( '.gift_icon' ).show() ;

                                $( '#referral_value_variable_product' ).addClass( 'woocommerce-info rs_message_for_single_product' ) ;
                                $( '#referral_value_variable_product' ).show() ;
                                $( '#referral_value_variable_product' ).html( response.data.refmsg ) ;
                            }
                            if ( fp_frontend_scripts_params.showpurchasemsg == '1' && response.data.purchasemsg != '' ) {
                                $( '#value_variable_product' ).addClass( 'woocommerce-info rs_message_for_single_product' ) ;
                                $( '#value_variable_product' ).show() ;
                                $( '#value_variable_product' ).html( response.data.purchasemsg ) ;
                                if ( fp_frontend_scripts_params.loggedinuser == "logged_in_user" ) {
                                    if ( fp_frontend_scripts_params.showearnmsg == '1' && response.data.earnpointmsg != '' ) {
                                        $( '.variableshopmessage' ).show() ;
                                        $( '.variableshopmessage' ).html( response.data.earnpointmsg ) ;
                                    }
                                } else {
                                    if ( fp_frontend_scripts_params.showearnmsg_guest == '1' && response.data.earnpointmsg != '' ) {
                                        $( '.variableshopmessage' ).show() ;
                                        $( '.variableshopmessage' ).html( response.data.earnpointmsg ) ;
                                    }
                                }
                            }
                            if ( fp_frontend_scripts_params.buyingmsg == '1' && response.data.buypoints != 0 && response.data.buypoints != '' && response.data.showbuypoint == '1' ) {
                                $( '#buy_Point_value_variable_product' ).addClass( 'woocommerce-info rs_message_for_single_product' ) ;
                                $( '#buy_Point_value_variable_product' ).show() ;
                                $( '#buy_Point_value_variable_product' ).html( response.data.buying_msg ) ;
                            }

                            if ( fp_frontend_scripts_params.loggedinuser == "logged_in_user" ) {
                                if ( fp_frontend_scripts_params.showearnmsg == '1' && response.data.earnpointmsg != '' ) {
                                    $( '.variableshopmessage' ).show() ;
                                    $( '.variableshopmessage' ).html( response.data.earnpointmsg ) ;
                                }
                            } else {
                                if ( fp_frontend_scripts_params.showearnmsg_guest == '1' && response.data.earnpointmsg != '' ) {
                                    $( '.variableshopmessage' ).show() ;
                                    $( '.variableshopmessage' ).html( response.data.earnpointmsg ) ;
                                }
                            }
                            if ( fp_frontend_scripts_params.showbuyingmsg == '1' && response.data.showbuypoint == '1' ) {
                                $( '.variableshopmessage' ).show() ;
                                if ( fp_frontend_scripts_params.loggedinuser == "logged_in_user" ) {
                                    if ( fp_frontend_scripts_params.showearnmsg == '1' && response.data.earnpointmsg != '' ) {
                                        $( '.variableshopmessage' ).append( '<br>' + response.data.buymsg + '</br>' ) ;
                                    } else {
                                        $( '.variableshopmessage' ).html( '<br>' + response.data.buymsg + '</br>' ) ;
                                    }
                                } else {
                                    if ( fp_frontend_scripts_params.showearnmsg_guest == '1' && response.data.earnpointmsg != '' ) {
                                        $( '.variableshopmessage' ).append( '<br>' + response.data.buymsg + '</br>' ) ;
                                    } else {
                                        $( '.variableshopmessage' ).html( '<br>' + response.data.buymsg + '</br>' ) ;
                                    }
                                }
                            }

                        } else {

                            if ( fp_frontend_scripts_params.showreferralmsg == '1' ) {
                                $( '#referral_value_variable_product' ).addClass( 'woocommerce-info rs_message_for_single_product' ) ;
                                $( '#referral_value_variable_product' ).show() ;
                                $( '#referral_value_variable_product' ).html( response.data.refmsg ) ;
                            }
                        }
                    } else {
                        window.alert( response.data.error ) ;
                    }
                } ) ;
            }
        } ,
    } ;
    FrontendScripts.init() ;
} ) ;
