<?php
/*
 * Simple Product Functionality
 */


if ( ! defined( 'ABSPATH' ) ) {
    exit ; // Exit if accessed directly.
}
if ( ! class_exists( 'RSFUnctinforVariableProduct' ) ) {

    class RSFUnctinforVariableProduct {

        public static function init() {

            add_action( 'woocommerce_before_single_product' , array( __CLASS__ , 'display_msg_for_variable_product' ) ) ;

            add_filter( 'woocommerce_get_price_html' , array( __CLASS__ , 'display_variation_price' ) , 10 , 2 ) ;

            add_shortcode( 'variationrewardpoints' , array( __CLASS__ , 'add_variation_shortcode_div' ) ) ;
            add_shortcode( 'variationreferralpoints' , array( __CLASS__ , 'add_variation_referral_shortcode_div' ) ) ;

            add_shortcode( 'variationpointprice' , array( __CLASS__ , 'add_variation_shortcode' ) ) ;
            add_shortcode( 'variationpointsvalue' , array( __CLASS__ , 'add_variation_point_values_shortcode' ) ) ;
            add_shortcode( 'variationreferralpointsamount' , array( __CLASS__ , 'add_variation_shortcode_referal' ) ) ;

            add_filter( 'woocommerce_ajax_variation_threshold' , array( __CLASS__ , 'rs_function_to_alert_the_variation_limit' ) , 999 , 2 ) ;

            add_action( 'wp_ajax_nopriv_getvariationpoints' , array( __CLASS__ , 'points_for_variation_in_product_page' ) ) ;
            add_action( 'wp_ajax_getvariationpoints' , array( __CLASS__ , 'points_for_variation_in_product_page' ) ) ;
        }

        public static function display_msg_for_variable_product() {
            if ( get_option( 'rs_enable_product_category_level_for_product_purchase' ) == 'no' && get_option( 'rs_award_points_for_cart_or_product_total' ) == '2' )
                return ;

            global $post ;
            if ( get_option( 'rs_enable_display_earn_message_for_variation_single_product' ) == 'yes' ) {
                $variableid   = RSFunctionforSimpleProduct::get_variation_id( $post->ID ) ;
                $earnmessages = '' ;
                $earnmessage  = '' ;
                $image        = '' ;
                if ( get_option( 'rs_enable_product_category_level_for_product_purchase' ) == 'no' && get_option( 'rs_award_points_for_cart_or_product_total' ) == '2' )
                    return ;

                $banning_type = FPRewardSystem::check_banning_type( get_current_user_id() ) ;
                if ( ! ($banning_type != 'earningonly' && $banning_type != 'both') )
                    return ;

                if ( is_array( $variableid ) && ! empty( $variableid ) ) {
                    $varpointss = RSFunctionforSimpleProduct::rewardpoints_of_variation( $variableid[ 0 ] , $post->ID ) ;
                    if ( $varpointss != '' ) {
                        $redeemingrspoints      = $varpointss / wc_format_decimal( get_option( 'rs_redeem_point' ) ) ;
                        $point_amount           = RSMemberFunction::user_role_based_redeem_points( get_current_user_id() ) ;
                        $updatedredeemingpoints = $redeemingrspoints * $point_amount ;
                        $currency               = number_format( ( float ) round_off_type_for_currency( $updatedredeemingpoints ) , get_option( 'woocommerce_price_num_decimals' ) ) ;
                        $message                = get_option( 'rs_message_for_variation_products' ) ;
                        $earnmessage            = str_replace( '[variationrewardpoints]' , round_off_type( $varpointss ) , $message ) ;
                        if ( get_option( 'woocommerce_currency_pos' ) == 'right' || get_option( 'woocommerce_currency_pos' ) == 'right_space' ) {
                            $currency = $currency . get_woocommerce_currency_symbol() ;
                        } elseif ( get_option( 'woocommerce_currency_pos' ) == 'left' || get_option( 'woocommerce_currency_pos' ) == 'left_space' ) {
                            $currency = get_woocommerce_currency_symbol() . $currency ;
                        }
                        $earnmessage  = str_replace( '[variationpointsvalue]' , $currency , $earnmessage ) ;
                        $messages     = get_option( "rs_message_for_single_product_variation" ) ;
                        $earnmessages = str_replace( '[variationrewardpoints]' , round_off_type( $varpointss ) , $messages ) ;
                        if ( get_option( '_rs_enable_disable_gift_icon' ) == '1' ) {
                            if ( get_option( 'rs_image_url_upload' ) != '' ) {
                                $image = "<img class = 'gifticon' src=" . get_option( 'rs_image_url_upload' ) . " style='width:16px;height:16px;display:inline;' />&nbsp;" ;
                            }
                        }
                        $earnmessages = $image . $earnmessages ;
                    }
                    $BuyPoints = get_post_meta( $variableid[ 0 ] , '_rewardsystem_assign_buying_points' , true ) ;
                    $BuyPoints = empty( get_current_user_id() ) ? $BuyPoints : RSMemberFunction::user_role_based_reward_points( get_current_user_id() , $BuyPoints ) ;
                    $BuyMsg    = ( ! empty( $BuyPoints )) ? str_replace( '[buypoints]' , $BuyPoints , get_option( 'rs_buy_point_message_in_product_page_for_variable' ) ) : '' ;

                    $redeemingrspoints      = $BuyPoints / wc_format_decimal( get_option( 'rs_redeem_point' ) ) ;
                    $point_amount           = RSMemberFunction::user_role_based_redeem_points( get_current_user_id() ) ;
                    $updatedredeemingpoints = $redeemingrspoints * $point_amount ;
                    $currency               = number_format( ( float ) round_off_type_for_currency( $updatedredeemingpoints ) , get_option( 'woocommerce_price_num_decimals' ) ) ;
                    $message                = get_option( 'rs_buy_point_message_for_variation_products' ) ;
                    $BuyingMsg              = str_replace( '[variationbuyingpoint]' , round_off_type( $BuyPoints ) , $message ) ;
                    if ( get_option( 'woocommerce_currency_pos' ) == 'right' || get_option( 'woocommerce_currency_pos' ) == 'right_space' ) {
                        $currency = $currency . get_woocommerce_currency_symbol() ;
                    } elseif ( get_option( 'woocommerce_currency_pos' ) == 'left' || get_option( 'woocommerce_currency_pos' ) == 'left_space' ) {
                        $currency = get_woocommerce_currency_symbol() . $currency ;
                    }
                    $BuyingMsg = str_replace( '[variationbuyingpointvalue]' , $currency , $BuyingMsg ) ;
                }
            }
            ?>
            <div id='value_variable_product'></div>
            <div id='buy_Point_value_variable_product'></div>
            <?php if ( isset( $_COOKIE[ 'rsreferredusername' ] ) ) { ?>
                <div id='referral_value_variable_product'></div>
            <?php } ?>
            <?php if ( get_option( 'rs_enable_display_earn_message_for_variation_single_product' ) == 'yes' && get_option( 'rs_product_purchase_activated' ) == 'yes' ) { ?>
                <div id='value_variable_product1'></div>
                <div id='value_variable_product2'></div>
                <?php
                if ( get_option( 'rs_enable_display_earn_message_for_variation_single_product' ) == 'yes' ) {
                    ?>
                    <script type='text/javascript'>
                        jQuery( document ).ready( function () {
                    <?php
                    if ( get_option( 'rs_show_hide_message_for_variable_product' ) == '1' && $earnmessage != '' ) {
                        ?>
                                jQuery( '#value_variable_product1' ).addClass( 'woocommerce-info rs_message_for_single_product' ) ;
                                jQuery( '#value_variable_product1' ).show() ;
                                jQuery( '.gift_icon' ).hide() ;
                                jQuery( '#value_variable_product1' ).html( "<?php echo $earnmessage ; ?>" ) ;
                        <?php
                    }
                    if ( get_option( 'rs_show_hide_buy_point_message_for_variable_product' ) == '1' && $BuyMsg != '' && $BuyPoints != 0 ) {
                        ?>
                                jQuery( '#value_variable_product2' ).addClass( 'woocommerce-info rs_message_for_single_product' ) ;
                                jQuery( '#value_variable_product2' ).show() ;
                                jQuery( '.gift_icon' ).hide() ;
                                jQuery( '#value_variable_product2' ).html( "<?php echo $BuyingMsg ; ?>" ) ;

                        <?php
                    }
                    if ( ! empty( get_current_user_id() ) ) {
                        if ( get_option( 'rs_show_hide_message_for_variable_in_single_product_page' ) == '1' ) {
                            ?>
                            <?php if ( $varpointss != '' && $earnmessages != '' ) { ?>
                                        jQuery( '.variableshopmessage' ).show() ;
                                        jQuery( '.variableshopmessage' ).html( "<?php echo $earnmessages ; ?>" ) ;
                                        jQuery( '.variableshopmessage' ).append( "<br><?php echo $BuyMsg ; ?><br>" ) ;
                            <?php } elseif ( $varpointss == '' && $BuyPoints != '' && $BuyPoints != 0 ) { ?>
                                        jQuery( '.variableshopmessage' ).show() ;
                                        jQuery( '.variableshopmessage' ).html( "<br><?php echo $BuyMsg ; ?><br>" ) ;
                            <?php } ?>

                            <?php
                        }
                    } else {
                        if ( get_option( 'rs_show_hide_buy_point_message_for_simple_in_product_guest' ) == '1' ) {
                            ?>
                            <?php
                        }
                    }
                    ?>
                        } ) ;
                    </script>
                    <?php
                }
            }
        }

        public static function display_variation_price( $cart_object , $compond ) {
            if ( is_product() || is_shop() || is_page() || is_product_category() ) {
                $id             = rs_get_id( $compond ) ;
                $gettheproducts = rs_get_product_object( $id ) ;
                if ( is_object( $gettheproducts ) && rs_check_variable_product_type( $gettheproducts ) ) {
                    $variation_idss = RSFunctionforSimpleProduct::get_variation_id( $id ) ;
                    foreach ( $variation_idss as $eachvariation ) {
                        $productid = $eachvariation ;
                        if ( check_display_price_type( $productid ) == '2' ) {
                            if ( get_option( 'rs_enable_disable_point_priceing' ) == '1' && get_option( 'rs_point_price_activated' ) == 'yes' ) {
                                $enable = calculate_point_price_for_products( $productid ) ;
                                if ( $enable[ $productid ] != '' ) {
                                    if ( get_option( 'rs_point_price_visibility' ) == '2' && ! is_user_logged_in() ) {
                                        return $cart_object ;
                                    } else {
                                        $cart_object = '' ;
                                    }
                                }
                            }
                        }
                    }
                }
                return $cart_object ;
            } else {
                return $cart_object ;
            }
        }

        public static function add_variation_shortcode_div() {
            return "<span class='variationrewardpoints' style='display:inline-block'></span>" ;
        }

        public static function add_variation_referral_shortcode_div() {
            return "<span class='variationreferralpoints' style='display:inline-block'></span>" ;
        }

        public static function add_variation_shortcode() {
            return "<span class='variationpoint_price' style='display:inline-block'></span>" ;
        }

        public static function add_variation_shortcode_referal() {
            if ( isset( $_COOKIE[ 'rsreferredusername' ] ) ) {
                if ( get_option( 'woocommerce_currency_pos' ) == 'right' || get_option( 'woocommerce_currency_pos' ) == 'right_space' ) {
                    return "<div class='variationreferralpointsamount' style='display:inline-block'></div>" . get_woocommerce_currency_symbol() ;
                } elseif ( get_option( 'woocommerce_currency_pos' ) == 'left' || get_option( 'woocommerce_currency_pos' ) == 'left_space' ) {
                    return get_woocommerce_currency_symbol() . "<div class='variationreferralpointsamount' style='display:inline-block'></div>" ;
                }
            }
        }

        public static function add_variation_point_values_shortcode() {
            if ( get_option( 'woocommerce_currency_pos' ) == 'right' || get_option( 'woocommerce_currency_pos' ) == 'right_space' ) {
                return "<div class='variationrewardpointsamount' style='display:inline-block'></div>" . get_woocommerce_currency_symbol() ;
            } elseif ( get_option( 'woocommerce_currency_pos' ) == 'left' || get_option( 'woocommerce_currency_pos' ) == 'left_space' ) {
                return get_woocommerce_currency_symbol() . "<div class='variationrewardpointsamount' style='display:inline-block'></div>" ;
            }
        }

        public static function points_for_variation_in_product_page() {
            check_ajax_referer( 'variation-msg' , 'sumo_security' ) ;

            if ( ! isset( $_POST ) || ! isset( $_POST[ 'variationid' ] ) )
                throw new exception( __( 'Invalid Request' , SRP_LOCALE ) ) ;

            try {
                $VarObj   = new WC_Product_Variation( $_POST[ 'variationid' ] ) ;
                $item     = array( 'qty' => '1' ) ;
                $ParentId = ! empty( $VarObj->get_parent_id() ) ? $VarObj->get_parent_id() : '' ;

                if ( isset( $_COOKIE[ 'rsreferredusername' ] ) ) {
                    $UserInfo         = get_user_by( 'login' , $_COOKIE[ 'rsreferredusername' ] ) ;
                    $Userid           = is_object( $UserInfo ) ? $UserInfo->ID : $_COOKIE[ 'rsreferredusername' ] ;
                    $RefPoints        = check_level_of_enable_reward_point( $ParentId , $_POST[ 'variationid' ] , $item , 'no' , 'yes' , 'no' , 'no' , '' , 'no' ) ;
                    $RefPoints        = empty( $Userid ) ? $RefPoints : RSMemberFunction::user_role_based_reward_points( $Userid , $RefPoints ) ;
                    $RedeemPercentage = RSMemberFunction::user_role_based_redeem_points( $Userid ) ;
                    $RefPoints        = ($RefPoints / wc_format_decimal( get_option( 'rs_redeem_point' ) )) * $RedeemPercentage ;
                    $RefCurrencyValue = round_off_type_for_currency( $RefPoints ) ;
                    $ValueToFind      = array( '[rsreferredusername]' , '[variationreferralpoints]' , '[variationreferralpointsamount]' ) ;
                    $ValueToReplace   = array( $_COOKIE[ 'rsreferredusername' ] , $RefPoints , wc_price( $RefCurrencyValue ) ) ;
                    $Refmsg           = str_replace( $ValueToFind , $ValueToReplace , get_option( 'rs_message_for_variation_products_referral' ) ) ;
                } else {
                    $Userid = get_current_user_id() ;
                    $Refmsg = '' ;
                }
                $banning_type = FPRewardSystem::check_banning_type( $Userid ) ;

                if ( $banning_type == 'earningonly' || $banning_type == 'both' )
                    wp_send_json_success( array( 'showmsg' => false ) ) ;

                $restrictpoints = block_points_for_salepriced_product( 0 , $_POST[ 'variationid' ] ) ;

                if ( $restrictpoints == 'yes' )
                    wp_send_json_success( array( 'showmsg' => false ) ) ;

                if ( get_option( 'rs_message_outofstockproducts_product_page' ) == '2' )
                    if ( ! $VarObj->is_in_stock() )
                        wp_send_json_success( array( 'showmsg' => false ) ) ;

                $VarPoints        = check_level_of_enable_reward_point( $ParentId , $_POST[ 'variationid' ] , $item , 'no' , '' , 'no' , 'no' , '' , 'no' ) ;
                $VarPoints        = empty( $Userid ) ? $VarPoints : RSMemberFunction::user_role_based_reward_points( $Userid , $VarPoints ) ;
                $RedeemPercentage = RSMemberFunction::user_role_based_redeem_points( $Userid ) ;
                $VarPointsValue   = ($VarPoints / wc_format_decimal( get_option( 'rs_redeem_point' ) )) * $RedeemPercentage ;
                if ( $VarPoints != "" || $VarPoints != 0 ) {

                    $VarPoints        = round_off_type( $VarPoints ) ;
                    $VarCurrencyValue = round_off_type_for_currency( $VarPointsValue ) ;
                    $VarEarnMsg       = str_replace( '[variationrewardpoints]' , $VarPoints , get_option( 'rs_message_for_single_product_variation' ) ) ;
                    $VarPurchaseMsg   = str_replace( '[variationrewardpoints]' , $VarPoints , get_option( 'rs_message_for_variation_products' ) ) ;
                    $VarPurchaseMsg   = str_replace( '[variationpointsvalue]' , wc_price( $VarCurrencyValue ) , $VarPurchaseMsg ) ;
                } else {
                    $VarEarnMsg     = '' ;
                    $VarPurchaseMsg = '' ;
                }

                $EnableBuyPoint         = get_post_meta( $_POST[ 'variationid' ] , '_rewardsystem_buying_reward_points' , true ) ;
                $BuyPoints              = get_post_meta( $_POST[ 'variationid' ] , '_rewardsystem_assign_buying_points' , true ) ;
                $BuyPoints              = empty( $Userid ) ? $BuyPoints : RSMemberFunction::user_role_based_reward_points( $Userid , $BuyPoints ) ;
                $BuyMsg                 = ($EnableBuyPoint == '1' && ! empty( $BuyPoints )) ? str_replace( '[buypoints]' , $BuyPoints , get_option( 'rs_buy_point_message_in_product_page_for_variable' ) ) : '' ;
                $redeemingrspoints      = $BuyPoints / wc_format_decimal( get_option( 'rs_redeem_point' ) ) ;
                $point_amount           = RSMemberFunction::user_role_based_redeem_points( get_current_user_id() ) ;
                $updatedredeemingpoints = $redeemingrspoints * $point_amount ;
                $currency               = number_format( ( float ) round_off_type_for_currency( $updatedredeemingpoints ) , get_option( 'woocommerce_price_num_decimals' ) ) ;
                $message                = get_option( 'rs_buy_point_message_for_variation_products' ) ;
                $BuyingMsg              = str_replace( '[variationbuyingpoint]' , round_off_type( $BuyPoints ) , $message ) ;
                if ( get_option( 'woocommerce_currency_pos' ) == 'right' || get_option( 'woocommerce_currency_pos' ) == 'right_space' ) {
                    $currency = $currency . get_woocommerce_currency_symbol() ;
                } elseif ( get_option( 'woocommerce_currency_pos' ) == 'left' || get_option( 'woocommerce_currency_pos' ) == 'left_space' ) {
                    $currency = get_woocommerce_currency_symbol() . $currency ;
                }
                $BuyingMsg = str_replace( '[variationbuyingpointvalue]' , $currency , $BuyingMsg ) ;

                wp_send_json_success( array(
                    'refmsg'       => $Refmsg ,
                    'earnpointmsg' => $VarEarnMsg ,
                    'purchasemsg'  => $VarPurchaseMsg ,
                    'buymsg'       => $BuyMsg ,
                    'showbuypoint' => $EnableBuyPoint ,
                    'buypoints'    => $BuyPoints ,
                    'buying_msg'   => $BuyingMsg
                ) ) ;
            } catch ( Exception $e ) {
                wp_send_json_error( array( 'error' => $e->getMessage() ) ) ;
            }
        }

        public static function rs_function_to_alert_the_variation_limit( $variation_limit , $product ) {
            $variation_limit = 1000 ;
            return $variation_limit ;
        }

    }

    RSFUnctinforVariableProduct::init() ;
}
